// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#pragma once

#include <SceneObject.h>

class IChangeListener
{
public:
	virtual ~IChangeListener(void) {}

	virtual void OnSceneChanged();
	virtual void OnSketchChanged();

	virtual void OnTreeSelectionChanged( const std::vector<rmsui::SceneObject *> & newSelection );
	virtual void OnMousePickSelectionChanged( const std::vector<rmsui::SceneObject *> & newSelection );

	virtual void OnSelectionParametersChanged( const std::vector<rmsui::SceneObject *> & vModified );

	virtual void OnCurrentBlobTreeChanged();

	virtual void OnRenderParametersChanged();

	virtual void OnCuttingPlaneEnabled( const Wml::Frame3f & vPlaneFrame );
	virtual void OnCuttingPlaneDisabled( );
};


inline void IChangeListener::OnSceneChanged()
{
}

inline void IChangeListener::OnSketchChanged()
{
}

inline void IChangeListener::OnTreeSelectionChanged( const std::vector<rmsui::SceneObject *> & newSelection )
{
}

inline void IChangeListener::OnMousePickSelectionChanged( const std::vector<rmsui::SceneObject *> & newSelection )
{
}

inline void IChangeListener::OnSelectionParametersChanged( const std::vector<rmsui::SceneObject *> & vModified )
{
}

inline void IChangeListener::OnCurrentBlobTreeChanged()
{
}

inline void IChangeListener::OnRenderParametersChanged()
{
}

inline void IChangeListener::OnCuttingPlaneEnabled( const Wml::Frame3f & vPlaneFrame )
{
}
inline void IChangeListener::OnCuttingPlaneDisabled( )
{
}
