// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#pragma once

#include "HUDButton.h"
#include "HUDToolbar.h"
#include "ViewController.h"


class HUDZoomButtonListener : public rmsui::HUDButtonEventHandler
{
public:
	HUDZoomButtonListener( CViewController * pViewController );
	~HUDZoomButtonListener() {}

	virtual void OnDragDelta( const Wml::Vector2f & vDelta );

protected:
	CViewController * m_pViewController;
};


class HUDPanButtonListener : public rmsui::HUDButtonEventHandler
{
public:
	HUDPanButtonListener( CViewController * pViewController );
	~HUDPanButtonListener() {}

	virtual void OnDragDelta( const Wml::Vector2f & vDelta );

protected:
	CViewController * m_pViewController;
};



class HUDOrbitButtonListener : public rmsui::HUDButtonEventHandler
{
public:
	HUDOrbitButtonListener( CViewController * pViewController );
	~HUDOrbitButtonListener() {}

	virtual void OnDragDelta( const Wml::Vector2f & vDelta );

protected:
	CViewController * m_pViewController;
};


class HUDStoredViewButtonListener : public rmsui::HUDButtonEventHandler
{
public:
	enum ViewDirection {
		Front, Back, Top, Bottom, Left, Right
	};

	HUDStoredViewButtonListener( CViewController * pViewController, ViewDirection eViewDirection );
	~HUDStoredViewButtonListener() {}

	virtual void OnCross();
	
protected:
	CViewController * m_pViewController;
	ViewDirection m_eViewDirection;
};




class HUDCrossingButtonListener : public rmsui::HUDButtonEventHandler
{
public:
	HUDCrossingButtonListener( );
	~HUDCrossingButtonListener() {}

	virtual void OnCross();
};





/*
 * View Toolbar Listener
 */
class HUDViewToolbarListener : public rmsui::IHUDToolbarEventHandler
{
public:
	HUDViewToolbarListener( CViewController * pViewController );
	~HUDViewToolbarListener() {}

	virtual void OnHUDToolbarMove( );
	virtual void OnHUDToolbarHide( );

protected:
	CViewController * m_pViewController;
};
