// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#pragma once


// CParametersDialogBar

#include "Parameters.h"
#include "ChangeListener.h"


class CParametersDialogBar : public CDialogBar, public IChangeListener
{
	DECLARE_DYNAMIC(CParametersDialogBar)

public:
	
	static CParametersDialogBar * Get();

	void SetParameters( const rmsui::ParameterList & paramList );

	void ClearParameters();


	/*
	 * IChangeListener functions
	 */
	virtual void OnTreeSelectionChanged( const std::vector<rmsui::SceneObject *> & newSelection );
	virtual void OnMousePickSelectionChanged( const std::vector<rmsui::SceneObject *> & newSelection );

	virtual void OnSelectionParametersChanged( );


protected:

	static CParametersDialogBar * m_spSingleton;

	CParametersDialogBar();
	virtual ~CParametersDialogBar();

	bool m_bColumnsInitialized;
	void InitializeColumns();

	void SynchronizeCurrentParameters();


	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLvnBeginlabeleditParamsdialogbarParamlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemActivateParamsdialogbarParamlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnEndlabeleditParamsdialogbarParamlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
};


