// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#include "stdafx.h"
#include "BasicParameters.h"

using namespace rmsui;


void BasicParameterOriginCoordinate::SendParameter( float fNewParameter ) {
	Wml::Vector3f origin( m_pTarget->GetFrame().Origin() );
	switch(m_eAxis) {
		case XAxis:	origin.X() = fNewParameter; break;
		case YAxis:	origin.Y() = fNewParameter; break;
		case ZAxis:	origin.Z() = fNewParameter; break;
		default: break;
	}
	m_pTarget->Translate( origin, false );
}

float BasicParameterOriginCoordinate::GetParameter( ) {
	switch(m_eAxis) {
		case XAxis:	return m_pTarget->GetFrame().Origin().X();
		case YAxis:	return m_pTarget->GetFrame().Origin().Y();
		case ZAxis:	return m_pTarget->GetFrame().Origin().Z();
		default: break;
	}
	return 0.0f;
}