// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef __RMSUI_BASIC_PARAMETERS_H__
#define __RMSUI_BASIC_PARAMETERS_H__

#include "Tool.h"
#include "Parameters.h"


namespace rmsui {

class BasicParameterOriginCoordinate : public rmsui::GenericFloatParameter
{
public:
	enum Axis { XAxis, YAxis, ZAxis };

	BasicParameterOriginCoordinate( const char * pParamName, ITool3DTarget * pTarget, Axis eAxis, bool bNoKeyFrame = false )
		: GenericFloatParameter( pParamName, pTarget->GetFrame().Origin().X() ),
		  m_pTarget(pTarget), m_eAxis(eAxis) { SetNoKeyFrame(bNoKeyFrame); }
	virtual ~BasicParameterOriginCoordinate() {};

protected:
	ITool3DTarget * m_pTarget;
	Axis m_eAxis;

	// these are the three functions that probably need to be implemented...
	virtual void GetMinMax( float & fMin, float & fMax ) {
		fMin = -100000.0f;
		fMax = 100000.0f;
	}

	virtual void SendParameter( float fNewParameter );

	virtual float GetParameter( );
};



} // namespace rmsui











#endif // __RMSUI_BASIC_PARAMETERS_H__