// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef RMS_GLUTIL_H
#define RMS_GLUTIL_H


#include <WmlVector3.h>
#include <WmlMatrix3.h>


namespace rmsui
{


class GLUtil
{
public:

	static void MakeGLLookAtMatrix( const Wml::Vector3f & vLookAt,
									const Wml::Vector3f & vUp,
									const Wml::Vector3f & vSide,
									float glMatrix[4][4] );

	template<typename T>
	static void WmlMatrix3ToGLMatrix( const Wml::Matrix3f & matrix,
									  T glMatrix[16])
	{
		memset(glMatrix, 0, sizeof(T)*16);
		glMatrix[3*4+3] = (T)1.0;
		glMatrix[0*4+0] = (T)matrix(0,0);
		glMatrix[0*4+1] = (T)matrix(0,1);
		glMatrix[0*4+2] = (T)matrix(0,2);
		glMatrix[1*4+0] = (T)matrix(1,0);
		glMatrix[1*4+1] = (T)matrix(1,1);
		glMatrix[1*4+2] = (T)matrix(1,2);
		glMatrix[2*4+0] = (T)matrix(2,0);
		glMatrix[2*4+1] = (T)matrix(2,1);
		glMatrix[2*4+2] = (T)matrix(2,2);
	}

private:
	GLUtil() {}
};


} // namespace rmsui



#endif // RMS_GLUTIL_H
