// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#include "StdAfx.h"
#include <gl/GL.h>
#include <gl/GLU.h>
#include <WmlDistLin3Lin3.h>

#include "Tool3DSurfaceTranslation.h"
#include "rmsdebug.h"

using namespace rmsui;

SurfaceTranslationTool3D::SurfaceTranslationTool3D()
	: ITool3D("SurfaceTranslation3D")
{
	m_surfaceTarget = Sphere( Wml::Vector3f::ZERO, 15.0f );
	m_nSelected = 0;
	m_pSurface = NULL;
}

void SurfaceTranslationTool3D::TargetFrameChanged()
{	
	ITool3D::TargetFrameChanged();
}


void SurfaceTranslationTool3D::Render( const ViewState & viewState ) 
{
	// render center circle
	m_surfaceTarget.Render( Wml::ColorRGBA::GREEN );
}


bool SurfaceTranslationTool3D::Intersect( const Wml::Ray3f & ray, 
									    Wml::Vector3f & ptPosition, float & fDepth )
{
	float fNearestDepth = Wml::Mathf::MAX_REAL;
	Wml::Vector3f ptTemp;
	float fTempDepth;

	// try center target
	if ( m_surfaceTarget.Intersect(ray, ptTemp, fTempDepth) && fTempDepth < fNearestDepth ) {
		fNearestDepth = fTempDepth;
		ptPosition = ptTemp;
		m_nSelected = 4;
	}

	if (fNearestDepth != Wml::Mathf::MAX_REAL) {
		fDepth = fNearestDepth;
		return true;
	} else {
		return false;
	}
}


Wml::Vector3f SurfaceTranslationTool3D::Move( SelectedTargetInfo & targetInfo,
										      const ViewState & viewState,
										      bool bInitialize )
{
	Wml::Vector3f curPosition(GetOrigin());

	// [RMS] disabled 
	//Wml::Vector3f vIntersection;
	//bool bHit = false;
	//if ( GetTargetSurface() ) {
	//	bHit = GetTargetSurface()->FindIntersection( targetInfo.eyeViewRay.Origin(), 
	//		targetInfo.eyeViewRay.Direction(), vIntersection );
	//}

	//if ( bHit && !bInitialize ) {
	//	// apply translation to object (do absolute transformation for now...)
	//	TranslateFrame(vIntersection, false);
	//}

	//// update last projection (return value)
	//targetInfo.ptLastFrame = vIntersection;
	
	return curPosition;
}
