// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef __RMSUI_TOOL3D_SURFACE_TRANSLATION_H__
#define __RMSUI_TOOL3D_SURFACE_TRANSLATION_H__

#include "Tool.h"
#include "Geometry.h"


namespace rmsui 
{


// this is a hack - need to have separate handles for each clickable thing
//   or some sort of sub-handle architecture...

class SurfaceTranslationTool3D : public ITool3D
{
public:
	SurfaceTranslationTool3D();

	virtual ~SurfaceTranslationTool3D() {}

	virtual void TargetFrameChanged();

	virtual void Render( const ViewState & viewState );

	virtual bool Intersect( const Wml::Ray3f & ray, 
							Wml::Vector3f & ptPosition, float & fDepth );

	virtual Wml::Vector3f Move( SelectedTargetInfo & targetInfo,
								const ViewState & viewState,
								bool bInitialize = false );

protected:
	Sphere m_surfaceTarget;
	unsigned int m_nSelected;
};


} // namespace rmsui


#endif   // __RMSUI_TOOL3D_SURFACE_TRANSLATION_H__