// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef _RMSUI_TOOLSET_H
#define _RMSUI_TOOLSET_H

#include <WmlRay3.h>
#include <Frame.h>
#include <set>


namespace rmsui
{

// predecl
class ITool3D;

class ToolSet {
public:
	typedef unsigned int ToolType;

	ToolType RegisterTool( ITool3D * pTool );
	void UnRegisterTool( ToolType nType );

	ITool3D * FindTool( ToolType nType );
	ITool3D * FindTool( const std::string & sToolName );
	ITool3D * GetNextTool( ToolType nType );

	ITool3D * GetDefaultTool();

	void ClearTools() { m_vTools.clear(); }

protected:
	static unsigned int m_sToolTypeGen;
	static ToolType GenToolType();

	struct ToolListEntry {
		unsigned int nType;
		ITool3D * pTool;

		bool operator<( const ToolListEntry & t2 ) const {
			return nType < t2.nType;
		}
	};

	std::set< ToolListEntry > m_vTools;
};


} // namespace rmsui


#endif // _RMSUI_TOOLSET_H