// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt

#ifndef __RMS_DEBUG_DATA_H__
#define __RMS_DEBUG_DATA_H__

#include <WmlVector2.h>
#include <WmlVector3.h>

#include "WmlExt.h"
#include "WmlColors.h"


#include <vector>

namespace Wml {


class WMLEXT_ITEM DebugData {
public:
	DebugData() {}
	~DebugData() {}

	void Clear();

	void AddLine( const Wml::Vector2f & v1, const Wml::Vector2f & v2,
				  const Wml::ColorRGB & color = Wml::ColorConstants::BLACK,
				  float fWidth = 1.0f );
	void AddLine( const Wml::Vector3f & v1, const Wml::Vector3f & v2,
				  const Wml::ColorRGB & color = Wml::ColorConstants::BLACK,
				  float fWidth = 1.0f );

	void AddPoint( const Wml::Vector3f & vPos, 
				   const Wml::ColorRGB & color = Wml::ColorConstants::BLACK );

	void RenderPoints();
	void RenderLines();

protected:
	struct LineStrip {
		std::vector<Wml::Vector3f> vVertices;
		Wml::ColorRGB color;
		float fWidth;
	};

	struct Line {
		Wml::Vector3f vPoint1, vPoint2;
		Wml::ColorRGB color;
		float fWidth;
	};

	struct Point {
		Wml::Vector3f vPosition;
		Wml::ColorRGB color;
	};

	std::vector<LineStrip> m_vLineStrips;
	std::vector<Line> m_vLines;
	std::vector<Point> m_vPoints;

};


} // end namespace wml;

#endif // __RMS_DEBUG_DATA_H__