// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef RMS_PGM_IMAGE_H
#define RMS_PGM_IMAGE_H

#include "WmlExt.h"

#include <vector>
#include <WmlColorRGB.h>

namespace Wml
{


class WMLEXT_ITEM PGMImage
{
public:
	PGMImage();
	PGMImage(unsigned int nWidth, unsigned int nHeight);

	bool Load( const char * pFilename );
	bool Save( const char * pFilename );

	unsigned int GetWidth() { return m_nWidth; }
	unsigned int GetHeight() { return m_nHeight; }
	void Resize( unsigned int nWidth, unsigned int nHeight );

	unsigned char GetPixelByte( unsigned int x, unsigned int y );
	float GetPixelFloat( unsigned int x, unsigned int y );

	void SetPixel( float fColor, unsigned int x, unsigned int y );
	void SetPixel( unsigned char nColor, unsigned int x, unsigned int y );

protected:
	std::vector<unsigned char> m_vValues;
	unsigned int m_nWidth;
	unsigned int m_nHeight;
};


} // namespace Wml

#endif // RMS_PGM_IMAGE_H